## innoextract 1.2%2bgit20120504

=== CMakeLists.txt ===
project(InnoExtract)

cmake_minimum_required(VERSION 2.8)

# For custom cmake modules.
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

option(USE_LZMA "Build lzma decompression support." ON)
option(DEBUG_EXTRA "Expensive debug options" OFF)

set(MAN_DIR "share/man" CACHE STRING "Install location for man pages (relative to prefix).")
mark_as_advanced(MAN_DIR)

include(CompileCheck)
include(VersionString)
include(CheckSymbolExists)
include(BuildType)
include(StyleCheck)
include(TestBigEndian)

# Force re-checking libraries if the compiler or compiler flags change.
if((NOT LAST_CMAKE_CXX_FLAGS STREQUAL CMAKE_CXX_FLAGS)
   OR (NOT LAST_CMAKE_CXX_COMPILER STREQUAL CMAKE_CXX_COMPILER))
	force_recheck_library(LZMA)
	force_recheck_library(Boost)
	unset(Boost_INCLUDE_DIR CACHE)
	set(LAST_CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}" CACHE INTERNAL "The last C++ compiler flags.")
	set(LAST_CMAKE_CXX_COMPILER "${CMAKE_CXX_COMPILER}" CACHE INTERNAL "The last C++ compiler.")
endif()

unset(LIBRARIES)

if(USE_LZMA)
	find_package(LZMA REQUIRED)
	check_link_library(LZMA LZMA_LIBRARIES)
	list(APPEND LIBRARIES "${LZMA_LIBRARIES}")
	include_directories(SYSTEM "${LZMA_INCLUDE_DIR}")
	set(HAVE_LZMA 1)
else()
	message(WARNING "\nDisabling LZMA decompression support.\n"
	                "You won't be able to extract most newer Inno Setup installers.")
	set(HAVE_LZMA 0)
endif()

find_package(Boost REQUIRED COMPONENTS
	iostreams
	filesystem
	date_time
	system
	program_options
)
check_link_library(Boost Boost_LIBRARIES)
list(APPEND LIBRARIES "${Boost_LIBRARIES}")
link_directories("${Boost_LIBRARY_DIRS}")
include_directories(SYSTEM "${Boost_INCLUDE_DIR}")

add_cxxflag("-Wall")
add_cxxflag("-Wextra")
add_cxxflag("-Wformat=2")
add_cxxflag("-Wundef")
add_cxxflag("-Wpointer-arith")
add_cxxflag("-Wcast-qual")
add_cxxflag("-Woverloaded-virtual")
add_cxxflag("-Wlogical-op")
add_cxxflag("-Wliteral-conversion")
add_cxxflag("-Wshift-overflow")
add_cxxflag("-Woverflow")
add_cxxflag("-Wbool-conversions")
add_cxxflag("-Wconversion")
add_cxxflag("-Wsign-conversion")
add_cxxflag("-Wmissing-declarations")
add_cxxflag("-Wredundant-decls")

if(DEBUG_EXTRA)
	add_cxxflag("-ftrapv") # to add checks for (undefined) signed integer overflow
	add_cxxflag("-fbounds-checking")
	add_cxxflag("-fcatch-undefined-behavior")
	add_cxxflag("-Wstrict-aliasing=1")
else()
	# -Wuninitialized causes too many false positives - thanks very much, gcc
	add_cxxflag("-Wno-uninitialized")
	# (clang only) Conflicts with using const variables for configuration.
	add_cxxflag("-Wno-constant-logical-operand")
	add_cxxflag("-Wno-unneeded-internal-declaration")
	add_cxxflag("-Wno-unused-function")
endif()

# Because i'm lazy
add_ldflag("-Wl,--as-needed")

check_symbol_exists(isatty "unistd.h" HAVE_ISATTY)
check_symbol_exists(ioctl "sys/ioctl.h" HAVE_IOCTL)

test_big_endian(IS_BIG_ENDIAN)

set(INNOEXTRACT_SOURCES
	
	src/cli/main.cpp
	
	src/crypto/adler32.cpp
	src/crypto/checksum.cpp
	src/crypto/crc32.cpp
	src/crypto/hasher.cpp
	src/crypto/md5.cpp
	src/crypto/sha1.cpp
	
	src/loader/exereader.cpp
	src/loader/offsets.cpp
	
	src/setup/component.cpp
	src/setup/data.cpp
	src/setup/delete.cpp
	src/setup/directory.cpp
	src/setup/expression.cpp
	src/setup/file.cpp
	src/setup/filename.cpp
	src/setup/header.cpp
	src/setup/icon.cpp
	src/setup/info.cpp
	src/setup/ini.cpp
	src/setup/item.cpp
	src/setup/language.cpp
	src/setup/message.cpp
	src/setup/permission.cpp
	src/setup/registry.cpp
	src/setup/run.cpp
	src/setup/task.cpp
	src/setup/type.cpp
	src/setup/version.cpp
	src/setup/windows.cpp
	
	src/stream/block.cpp
	src/stream/chunk.cpp
	src/stream/file.cpp
	
	src/stream/slice.cpp
	src/util/console.cpp
	src/util/load.cpp
	src/util/log.cpp
	
)

if(DEBUG)
	list(APPEND INNOEXTRACT_SOURCES src/cli/debug.cpp)
endif()

if(LZMA_FOUND)
	list(APPEND INNOEXTRACT_SOURCES src/stream/lzma.cpp)
endif()

file(GLOB_RECURSE ALL_INCLUDES "${CMAKE_SOURCE_DIR}/src/*.hpp")

list(SORT INNOEXTRACT_SOURCES)
list(SORT ALL_INCLUDES)

include_directories(src ${CMAKE_CURRENT_BINARY_DIR})

configure_file("src/configure.hpp.in" "configure.hpp")

set(VERSION_FILE "${CMAKE_BINARY_DIR}/version.cpp")
version_file("src/version.cpp.in" "${VERSION_FILE}" "VERSION" ".git")
list(APPEND INNOEXTRACT_SOURCES "${VERSION_FILE}")

add_executable(innoextract ${INNOEXTRACT_SOURCES} ${ALL_INCLUDES})
target_link_libraries(innoextract ${LIBRARIES})

install(TARGETS innoextract RUNTIME DESTINATION bin)

install(FILES doc/innoextract.1 DESTINATION ${MAN_DIR}/man1 OPTIONAL)

# Additional targets.

add_style_check_target(style "${INNOEXTRACT_SOURCES}" "${ALL_INCLUDES}")

## innoextract 1.2+git20120504

=== debian/changelog ===
innoextract (1.2+git20120504-1) unstable; urgency=low

  * Initial release. (Closes: #678294)

 -- Lennart Weller <lhw@ring0.de>  Wed, 20 Jun 2012 18:12:47 +0200

=== debian/control ===
Source: innoextract
Section: utils
Priority: extra
Maintainer: Lennart Weller <lhw@ring0.de>
Uploaders: Sebastian Reichel <sre@debian.org>
Standards-Version: 3.9.3
Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
Homepage: https://github.com/dscharrer/InnoExtract
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-date-time-dev,
               libboost-system-dev,
               libboost-program-options-dev,
               liblzma-dev

Package: innoextract
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tool for extracting data from an Inno Setup installer
 Inno Setup is a tool to create installers for Microsoft Windows applications.
 Inno Extracts allows one to extract such installers under non-windows systems
 without running the actual installer using wine. Inno Extract currently
 supports installers created by Inno Setup 1.2.10 to 5.4.3.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr

## innoextract 1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 include(CheckSymbolExists)
 include(BuildType)
 include(StyleCheck)
+include(Doxygen)
 include(TestBigEndian)
 
 # Force re-checking libraries if the compiler or compiler flags change.
@@ -53,6 +54,8 @@
 list(APPEND LIBRARIES "${Boost_LIBRARIES}")
 link_directories("${Boost_LIBRARY_DIRS}")
 include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
+
+add_cxxflag("-std=c++11")
 
 add_cxxflag("-Wall")
 add_cxxflag("-Wextra")
@@ -157,8 +160,9 @@
 
 configure_file("src/configure.hpp.in" "configure.hpp")
 
-set(VERSION_FILE "${CMAKE_BINARY_DIR}/version.cpp")
-version_file("src/version.cpp.in" "${VERSION_FILE}" "VERSION" ".git")
+file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/cli")
+set(VERSION_FILE "${CMAKE_BINARY_DIR}/cli/version.cpp")
+version_file("src/cli/version.cpp.in" "${VERSION_FILE}" "VERSION" ".git")
 list(APPEND INNOEXTRACT_SOURCES "${VERSION_FILE}")
 
 add_executable(innoextract ${INNOEXTRACT_SOURCES} ${ALL_INCLUDES})
@@ -171,3 +175,5 @@
 # Additional targets.
 
 add_style_check_target(style "${INNOEXTRACT_SOURCES}" "${ALL_INCLUDES}")
+
+add_doxygen_target(doc "doc/Doxyfile.in" "VERSION" ".git" "${CMAKE_BINARY_DIR}/doc")

=== debian/changelog ===
innoextract (1.3-1build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:41 +0100

innoextract (1.3-1) unstable; urgency=low

  * New upstream release
  * Update Debian Standards Version to 3.9.4

 -- Lennart Weller <lhw@ring0.de>  Thu, 25 Oct 2012 23:01:31 +0200

innoextract (1.2+git20120504-2) unstable; urgency=low

  * introduced hardening to the binary to solve all warnings

 -- Lennart Weller <lhw@ring0.de>  Thu, 04 Oct 2012 23:05:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: innoextract
 Section: utils
 Priority: extra
-Maintainer: Lennart Weller <lhw@ring0.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
 Homepage: https://github.com/dscharrer/InnoExtract
 Build-Depends: cmake,
                debhelper (>= 9),
+               dpkg-dev (>= 1.16.1~),
                libboost-iostreams-dev,
                libboost-filesystem-dev,
                libboost-date-time-dev,

## innoextract 1.4

=== CMakeLists.txt ===
project(innoextract)

cmake_minimum_required(VERSION 2.8)


# Define configuration options

option(USE_LZMA "Build lzma decompression support." ON)
option(DEBUG_EXTRA "Expensive debug options" OFF)
option(SET_WARNING_FLAGS "Adjust compiler warning flags" ON)
option(SET_OPTIMIZATION_FLAGS "Adjust compiler optimization flags" ON)
option(USE_CXX11 "Try to use C++11 if available" ON)

set(default_USE_STATIC_LIBS OFF)
if(WIN32)
	set(default_USE_STATIC_LIBS ON)
endif()
option(USE_STATIC_LIBS       "Statically link libraries" ${default_USE_STATIC_LIBS})
option(LZMA_USE_STATIC_LIBS  "Statically link liblzma"   ${USE_STATIC_LIBS})
option(ZLIB_USE_STATIC_LIBS  "Statically link libz"      ${USE_STATIC_LIBS})
option(BZip2_USE_STATIC_LIBS "Statically link libbz2"    ${USE_STATIC_LIBS})
option(Boost_USE_STATIC_LIBS "Statically link Boost"     ${USE_STATIC_LIBS})
option(iconv_USE_STATIC_LIBS "Statically link libiconv"  ${USE_STATIC_LIBS})


# Install destinations
if(CMAKE_VERSION VERSION_LESS 2.8.5)
	set(CMAKE_INSTALL_DATAROOTDIR "share" CACHE
			STRING "read-only architecture-independent data root (share) (relative to prefix).")
	set(CMAKE_INSTALL_BINDIR "bin" CACHE
			STRING "user executables (bin) (relative to prefix).")
	set(CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_DATAROOTDIR}/man" CACHE
			STRING "man documentation (DATAROOTDIR/man) (relative to prefix).")
	mark_as_advanced(
		CMAKE_INSTALL_DATAROOTDIR
		CMAKE_INSTALL_BINDIR
		CMAKE_INSTALL_MANDIR
	)
else()
	include(GNUInstallDirs)
endif()


# Helper scrips

include(CheckSymbolExists)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake") # For custom cmake modules
include(BuildType)
include(CompileCheck)
include(CXX11Check)
include(Doxygen)
include(PrintConfiguration)
include(StyleCheck)
include(UseStaticLibs)
include(VersionString)


# Find required libraries

# Win32 API
if(WIN32)
	# Ensure we aren't using functionalities not found under Window XP SP1
	add_definitions(-D_WIN32_WINNT=0x0502)
	add_definitions(-DNOMINMAX)
	add_definitions(-DWIN32_LEAN_AND_MEAN)
	if(NOT MSVC)
		 # required for _gmtime64_s on MinGW
		add_definitions(-DMINGW_HAS_SECURE_API)
		list(APPEND CMAKE_REQUIRED_DEFINITIONS -DMINGW_HAS_SECURE_API)
	endif()
endif()

if(USE_STATIC_LIBS AND NOT MSVC)
	add_ldflag("-static-libstdc++")
	add_ldflag("-static-libgcc")
endif()

# Force re-checking libraries if the compiler or compiler flags change
if((NOT LAST_CMAKE_CXX_FLAGS STREQUAL CMAKE_CXX_FLAGS)
   OR (NOT LAST_CMAKE_CXX_COMPILER STREQUAL CMAKE_CXX_COMPILER))
	force_recheck_library(LZMA)
	force_recheck_library(Boost)
	force_recheck_library(ZLIB)
	force_recheck_library(BZip2)
	force_recheck_library(iconv)
	unset(Boost_INCLUDE_DIR CACHE)
	set(LAST_CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}" CACHE INTERNAL
	    "The last C++ compiler flags")
	set(LAST_CMAKE_CXX_COMPILER "${CMAKE_CXX_COMPILER}" CACHE INTERNAL
	    "The last C++ compiler")
endif()

unset(LIBRARIES)

if(USE_LZMA)
	find_package(LZMA REQUIRED)
	check_link_library(LZMA LZMA_LIBRARIES)
	list(APPEND LIBRARIES ${LZMA_LIBRARIES})
	include_directories(SYSTEM ${LZMA_INCLUDE_DIR})
	add_definitions(${LZMA_DEFINITIONS})
	set(INNOEXTRACT_HAVE_LZMA 1)
else()
	message(WARNING "\nDisabling LZMA decompression support.\n"
	                "You won't be able to extract most newer Inno Setup installers.")
	set(INNOEXTRACT_HAVE_LZMA 0)
endif()

find_package(Boost REQUIRED COMPONENTS
	iostreams
	filesystem
	date_time
	system
	program_options
)
check_link_library(Boost Boost_LIBRARIES)
list(APPEND LIBRARIES ${Boost_LIBRARIES})
link_directories(${Boost_LIBRARY_DIRS})
include_directories(SYSTEM ${Boost_INCLUDE_DIR})

if(Boost_USE_STATIC_LIBS)
	
	use_static_libs(ZLIB)
	find_package(ZLIB REQUIRED)
	use_static_libs_restore()
	check_link_library(ZLIB ZLIB_LIBRARIES)
	list(APPEND LIBRARIES ${ZLIB_LIBRARIES})
	
	use_static_libs(BZip2)
	find_package(BZip2 REQUIRED)
	use_static_libs_restore()
	check_link_library(BZip2 BZIP2_LIBRARIES)
	list(APPEND LIBRARIES ${BZIP2_LIBRARIES})
	
endif()

find_package(iconv REQUIRED)
check_link_library(iconv iconv_LIBRARIES)
list(APPEND LIBRARIES ${iconv_LIBRARIES})
include_directories(SYSTEM ${iconv_INCLUDE_DIR})
add_definitions(${iconv_DEFINITIONS})


# Set compiler flags

if(${Boost_VERSION} LESS 104800)
	# Older Boost versions don't work with C++11
elseif(USE_CXX11)
	enable_cxx11()
	check_cxx11("alignof" INNOEXTRACT_HAVE_ALIGNOF)
	if(WIN32)
		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16)
	endif()
	check_cxx11("std::unique_ptr" INNOEXTRACT_HAVE_STD_UNIQUE_PTR)
endif()

# Don't expose internal symbols to the outside world by default
if(NOT MSVC)
	add_cxxflag("-fvisibility=hidden")
	add_cxxflag("-fvisibility-inlines-hidden")
endif()

# Older glibc versions won't provide some useful symbols by default - request them
# This flag is currently also set by gcc when compiling C++, but not for plain C
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
	add_definitions(-D_GNU_SOURCE=1)
endif()

if(WIN32)
	# Define this so that we don't accitenally use ANSI functions
	add_definitions(-D_UNICODE)
endif()


# Check for optional functionality and system configuration

check_symbol_exists(isatty "unistd.h" INNOEXTRACT_HAVE_ISATTY)
if(NOT INNOEXTRACT_HAVE_ISATTY)
	check_symbol_exists(_isatty "io.h" INNOEXTRACT_HAVE_MS_ISATTY)
endif()
check_symbol_exists(ioctl "sys/ioctl.h" INNOEXTRACT_HAVE_IOCTL)
check_symbol_exists(_mkgmtime64 "time.h" INNOEXTRACT_HAVE_MKGMTIME64)
if(NOT INNOEXTRACT_HAVE_MKGMTIME64)
	check_symbol_exists(timegm "time.h" INNOEXTRACT_HAVE_TIMEGM)
	if(NOT INNOEXTRACT_HAVE_TIMEGM)
		check_symbol_exists(_mkgmtime "time.h" INNOEXTRACT_HAVE_MKGMTIME)
	endif()
endif()
check_symbol_exists(_gmtime64_s "time.h" INNOEXTRACT_HAVE_GMTIME64_S)
if(NOT INNOEXTRACT_HAVE_GMTIME64_S)
	check_symbol_exists(gmtime_r "time.h" INNOEXTRACT_HAVE_GMTIME_R)
	if(NOT INNOEXTRACT_HAVE_GMTIME_R)
		check_symbol_exists(gmtime_s "time.h" INNOEXTRACT_HAVE_GMTIME_S)
	endif()
endif()
if(NOT WIN32)
	check_symbol_exists(utimensat "sys/stat.h" INNOEXTRACT_HAVE_UTIMENSAT)
	check_symbol_exists(AT_FDCWD "fcntl.h" INNOEXTRACT_HAVE_AT_FDCWD)
	if(INNOEXTRACT_HAVE_UTIMENSAT AND INNOEXTRACT_HAVE_AT_FDCWD)
		set(INNOEXTRACT_HAVE_UTIMENSAT_d 1)
	else()
		check_symbol_exists(utimes "sys/time.h" INNOEXTRACT_HAVE_UTIMES)
	endif()
endif()

check_symbol_exists(bswap_16 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_16)
check_symbol_exists(bswap_32 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_32)
check_symbol_exists(bswap_64 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_64)


# All sources:

set(INNOEXTRACT_SOURCES
	
	src/cli/main.cpp
	
	src/crypto/adler32.cpp
	src/crypto/checksum.cpp
	src/crypto/crc32.cpp
	src/crypto/hasher.cpp
	src/crypto/md5.cpp
	src/crypto/sha1.cpp
	
	src/loader/exereader.cpp
	src/loader/offsets.cpp
	
	src/setup/component.cpp
	src/setup/data.cpp
	src/setup/delete.cpp
	src/setup/directory.cpp
	src/setup/expression.cpp
	src/setup/file.cpp
	src/setup/filename.cpp
	src/setup/header.cpp
	src/setup/icon.cpp
	src/setup/info.cpp
	src/setup/ini.cpp
	src/setup/item.cpp
	src/setup/language.cpp
	src/setup/message.cpp
	src/setup/permission.cpp
	src/setup/registry.cpp
	src/setup/run.cpp
	src/setup/task.cpp
	src/setup/type.cpp
	src/setup/version.cpp
	src/setup/windows.cpp
	
	src/stream/block.cpp
	src/stream/chunk.cpp
	src/stream/file.cpp
	
	src/stream/slice.cpp
	src/util/console.cpp
	src/util/load.cpp
	src/util/log.cpp
	src/util/time.cpp
	
)

if(DEBUG)
	list(APPEND INNOEXTRACT_SOURCES src/cli/debug.cpp)
endif()

if(LZMA_FOUND)
	list(APPEND INNOEXTRACT_SOURCES src/stream/lzma.cpp)
endif()

if(WIN32)
	list(APPEND INNOEXTRACT_SOURCES src/util/windows.cpp)
endif()

file(GLOB_RECURSE ALL_INCLUDES "${CMAKE_SOURCE_DIR}/src/*.hpp")

list(SORT INNOEXTRACT_SOURCES)
list(SORT ALL_INCLUDES)

list(APPEND CHECKED_SOURCES ${INNOEXTRACT_SOURCES})


# Prepare generated files

include_directories(src ${CMAKE_CURRENT_BINARY_DIR})

configure_file("src/configure.hpp.in" "configure.hpp")

set(VERSION_FILE "${CMAKE_BINARY_DIR}/release.cpp")
set(VERSION_SOURCES VERSION "VERSION" LICENSE "LICENSE")
version_file("src/release.cpp.in" "${VERSION_FILE}" "${VERSION_SOURCES}" ".git")
list(APPEND INNOEXTRACT_SOURCES "${VERSION_FILE}")


# Main targets

add_executable(innoextract ${INNOEXTRACT_SOURCES} ${ALL_INCLUDES})
target_link_libraries(innoextract ${LIBRARIES})

install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES doc/innoextract.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 OPTIONAL)


# Additional targets.

add_style_check_target(style "${CHECKED_SOURCES}" "${ALL_INCLUDES}")

add_doxygen_target(doc "doc/Doxyfile.in" "VERSION" ".git" "${CMAKE_BINARY_DIR}/doc")


# Print a configuration summary

message("")
message("Configuration:")
message(" - Build type: ${CMAKE_BUILD_TYPE}")
print_configuration("LZMA decompression" FIRST
	INNOEXTRACT_HAVE_LZMA "enabled"
	1                     "disabled"
)
print_configuration("File time precision" FIRST
	INNOEXTRACT_HAVE_UTIMENSAT_d "nanoseconds"
	WIN32                        "100-nanoseconds"
	INNOEXTRACT_HAVE_UTIMES      "microseconds"
	1                            "seconds"
)
message("")

=== debian/changelog ===
innoextract (1.4-1) unstable; urgency=low

  * New upstream release (Closes: #730524)

 -- Lennart Weller <lhw@ring0.de>  Wed, 27 Nov 2013 15:42:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: innoextract
 Section: utils
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
+Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
 Standards-Version: 3.9.4
 Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git

=== debian/watch ===
version=3
opts="uversionmangle=s/^v//" \
http://githubredir.debian.net/github/dscharrer/InnoExtract/(.+)\.tar\.gz

## innoextract 1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,11 +5,20 @@
 
 # Define configuration options
 
-option(USE_LZMA "Build lzma decompression support." ON)
+option(USE_LZMA "Build lzma decompression support" ON)
+set(WITH_CONV CACHE STRING "The library to use for charset conversions")
+option(ENABLE_BUILTIN_CONV "Build internal charset conversion routines" ON)
 option(DEBUG_EXTRA "Expensive debug options" OFF)
 option(SET_WARNING_FLAGS "Adjust compiler warning flags" ON)
 option(SET_OPTIMIZATION_FLAGS "Adjust compiler optimization flags" ON)
 option(USE_CXX11 "Try to use C++11 if available" ON)
+option(USE_DYNAMIC_UTIMENSAT "Dynamically load utimensat if not available at compile time" OFF)
+if(NOT DEFINED DEBUG AND CMAKE_BUILD_TYPE STREQUAL "Debug")
+	set(DEBUG 1)
+endif()
+if(DEBUG)
+	add_definitions(-DDEBUG=1)
+endif()
 
 set(default_USE_STATIC_LIBS OFF)
 if(WIN32)
@@ -48,8 +57,10 @@
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake") # For custom cmake modules
 include(BuildType)
 include(CompileCheck)
+include(CreateSourceGroups)
 include(CXX11Check)
 include(Doxygen)
+include(FilterList)
 include(PrintConfiguration)
 include(StyleCheck)
 include(UseStaticLibs)
@@ -64,11 +75,6 @@
 	add_definitions(-D_WIN32_WINNT=0x0502)
 	add_definitions(-DNOMINMAX)
 	add_definitions(-DWIN32_LEAN_AND_MEAN)
-	if(NOT MSVC)
-		 # required for _gmtime64_s on MinGW
-		add_definitions(-DMINGW_HAS_SECURE_API)
-		list(APPEND CMAKE_REQUIRED_DEFINITIONS -DMINGW_HAS_SECURE_API)
-	endif()
 endif()
 
 if(USE_STATIC_LIBS AND NOT MSVC)
@@ -118,7 +124,8 @@
 link_directories(${Boost_LIBRARY_DIRS})
 include_directories(SYSTEM ${Boost_INCLUDE_DIR})
 
-if(Boost_USE_STATIC_LIBS)
+has_static_libs(Boost Boost_LIBRARIES)
+if(Boost_HAS_STATIC_LIBS)
 	
 	use_static_libs(ZLIB)
 	find_package(ZLIB REQUIRED)
@@ -134,11 +141,33 @@
 	
 endif()
 
-find_package(iconv REQUIRED)
-check_link_library(iconv iconv_LIBRARIES)
-list(APPEND LIBRARIES ${iconv_LIBRARIES})
-include_directories(SYSTEM ${iconv_INCLUDE_DIR})
-add_definitions(${iconv_DEFINITIONS})
+set(INNOEXTRACT_HAVE_ICONV 0)
+set(INNOEXTRACT_HAVE_WIN32_CONV 0)
+set(INNOEXTRACT_HAVE_BUILTIN_CONV ${ENABLE_BUILTIN_CONV})
+if(WIN32 AND (NOT WITH_CONV OR WITH_CONV STREQUAL "win32"))
+	set(INNOEXTRACT_HAVE_WIN32_CONV 1)
+elseif(NOT WITH_CONV OR WITH_CONV STREQUAL "iconv")
+	if(STRICT_USE)
+		set(ICONV_REQUIRED REQUIRED)
+	else()
+		set(ICONV_REQUIRED)
+	endif()
+	find_package(iconv ${ICONV_REQUIRED})
+	if(ICONV_FOUND)
+		check_link_library(iconv iconv_LIBRARIES)
+		list(APPEND LIBRARIES ${iconv_LIBRARIES})
+		include_directories(SYSTEM ${iconv_INCLUDE_DIR})
+		add_definitions(${iconv_DEFINITIONS})
+		set(INNOEXTRACT_HAVE_ICONV 1)
+	endif()
+elseif(WITH_CONV AND NOT WITH_CONV STREQUAL "builtin")
+	message(FATAL_ERROR "Invalid WITH_CONV option: ${WITH_CONV}")
+endif()
+if(NOT INNOEXTRACT_HAVE_ICONV AND NOT INNOEXTRACT_HAVE_WIN32_CONV
+   AND NOT INNOEXTRACT_HAVE_BUILTIN_CONV)
+	message(WARNING "\nBuilding without any charset conversion support.\n"
+	                "Any non-ASCII characters in extracted filenames will be missing.")
+endif()
 
 
 # Set compiler flags
@@ -149,9 +178,9 @@
 	enable_cxx11()
 	check_cxx11("alignof" INNOEXTRACT_HAVE_ALIGNOF)
 	if(WIN32)
-		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16)
-	endif()
-	check_cxx11("std::unique_ptr" INNOEXTRACT_HAVE_STD_UNIQUE_PTR)
+		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16 1600)
+	endif()
+	check_cxx11("std::unique_ptr" INNOEXTRACT_HAVE_STD_UNIQUE_PTR 1600)
 endif()
 
 # Don't expose internal symbols to the outside world by default
@@ -169,114 +198,194 @@
 
 if(WIN32)
 	# Define this so that we don't accitenally use ANSI functions
+	add_definitions(-DUNICODE)
 	add_definitions(-D_UNICODE)
 endif()
 
 
 # Check for optional functionality and system configuration
 
-check_symbol_exists(isatty "unistd.h" INNOEXTRACT_HAVE_ISATTY)
-if(NOT INNOEXTRACT_HAVE_ISATTY)
-	check_symbol_exists(_isatty "io.h" INNOEXTRACT_HAVE_MS_ISATTY)
-endif()
-check_symbol_exists(ioctl "sys/ioctl.h" INNOEXTRACT_HAVE_IOCTL)
-check_symbol_exists(_mkgmtime64 "time.h" INNOEXTRACT_HAVE_MKGMTIME64)
-if(NOT INNOEXTRACT_HAVE_MKGMTIME64)
+if(NOT WIN32)
+	
+	check_symbol_exists(isatty "unistd.h" INNOEXTRACT_HAVE_ISATTY)
+	check_symbol_exists(ioctl "sys/ioctl.h" INNOEXTRACT_HAVE_IOCTL)
 	check_symbol_exists(timegm "time.h" INNOEXTRACT_HAVE_TIMEGM)
-	if(NOT INNOEXTRACT_HAVE_TIMEGM)
-		check_symbol_exists(_mkgmtime "time.h" INNOEXTRACT_HAVE_MKGMTIME)
-	endif()
-endif()
-check_symbol_exists(_gmtime64_s "time.h" INNOEXTRACT_HAVE_GMTIME64_S)
-if(NOT INNOEXTRACT_HAVE_GMTIME64_S)
 	check_symbol_exists(gmtime_r "time.h" INNOEXTRACT_HAVE_GMTIME_R)
-	if(NOT INNOEXTRACT_HAVE_GMTIME_R)
-		check_symbol_exists(gmtime_s "time.h" INNOEXTRACT_HAVE_GMTIME_S)
-	endif()
-endif()
-if(NOT WIN32)
-	check_symbol_exists(utimensat "sys/stat.h" INNOEXTRACT_HAVE_UTIMENSAT)
 	check_symbol_exists(AT_FDCWD "fcntl.h" INNOEXTRACT_HAVE_AT_FDCWD)
+	if(INNOEXTRACT_HAVE_AT_FDCWD)
+		check_symbol_exists(utimensat "sys/stat.h" INNOEXTRACT_HAVE_UTIMENSAT)
+	endif()
 	if(INNOEXTRACT_HAVE_UTIMENSAT AND INNOEXTRACT_HAVE_AT_FDCWD)
 		set(INNOEXTRACT_HAVE_UTIMENSAT_d 1)
 	else()
+		if(USE_DYNAMIC_UTIMENSAT AND INNOEXTRACT_HAVE_AT_FDCWD)
+			set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS})
+			check_symbol_exists(dlsym "dlfcn.h" INNOEXTRACT_HAVE_DLSYM)
+			check_symbol_exists(RTLD_DEFAULT "dlfcn.h" INNOEXTRACT_HAVE_RTLD_DEFAULT)
+			unset(CMAKE_REQUIRED_LIBRARIES)
+			if(INNOEXTRACT_HAVE_DLSYM AND INNOEXTRACT_HAVE_RTLD_DEFAULT)
+				set(INNOEXTRACT_HAVE_DYNAMIC_UTIMENSAT 1)
+				if(CMAKE_DL_LIBS)
+					list(APPEND LIBRARIES ${CMAKE_DL_LIBS})
+				endif()
+			endif()
+		endif()
 		check_symbol_exists(utimes "sys/time.h" INNOEXTRACT_HAVE_UTIMES)
 	endif()
-endif()
-
-check_symbol_exists(bswap_16 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_16)
-check_symbol_exists(bswap_32 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_32)
-check_symbol_exists(bswap_64 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_64)
+	check_symbol_exists(posix_spawnp "spawn.h" INNOEXTRACT_HAVE_POSIX_SPAWNP)
+	if(NOT INNOEXTRACT_HAVE_POSIX_SPAWNP)
+		check_symbol_exists(fork "unistd.h" INNOEXTRACT_HAVE_FORK)
+		check_symbol_exists(execvp "unistd.h" INNOEXTRACT_HAVE_EXECVP)
+	endif()
+	if(INNOEXTRACT_HAVE_POSIX_SPAWNP OR (INNOEXTRACT_HAVE_FORK AND INNOEXTRACT_HAVE_EXECVP))
+		check_symbol_exists(waitpid "sys/wait.h" INNOEXTRACT_HAVE_WAITPID)
+	endif()
+	
+	if(CMAKE_CXX_COMPILER_ID STREQUAL "PathScale")
+		# EKOPath recognizes these but then fails to link
+	else()
+		check_builtin(INNOEXTRACT_HAVE_BUILTIN_BSWAP16 "__builtin_bswap16(0)")
+		check_builtin(INNOEXTRACT_HAVE_BUILTIN_BSWAP32 "__builtin_bswap32(0)")
+		check_builtin(INNOEXTRACT_HAVE_BUILTIN_BSWAP64 "__builtin_bswap64(0)")
+	endif()
+	if(NOT INNOEXTRACT_HAVE_BUILTIN_BSWAP16)
+		check_symbol_exists(bswap_16 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_16)
+	endif()
+	if(NOT INNOEXTRACT_HAVE_BUILTIN_BSWAP32)
+		check_symbol_exists(bswap_32 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_32)
+	endif()
+	if(NOT INNOEXTRACT_HAVE_BUILTIN_BSWAP64)
+		check_symbol_exists(bswap_64 "byteswap.h" INNOEXTRACT_HAVE_BSWAP_64)
+	endif()
+	
+endif()
 
 
 # All sources:
 
+set(DOCUMENTATION 0) # never build these
+
 set(INNOEXTRACT_SOURCES
 	
+	src/index.hpp if DOCUMENTATION
+	src/release.hpp
+	
+	src/cli/debug.hpp
+	src/cli/debug.cpp if DEBUG
+	src/cli/extract.hpp
+	src/cli/extract.cpp
+	src/cli/gog.hpp
+	src/cli/gog.cpp
 	src/cli/main.cpp
 	
+	src/crypto/adler32.hpp
 	src/crypto/adler32.cpp
+	src/crypto/checksum.hpp
 	src/crypto/checksum.cpp
+	src/crypto/crc32.hpp
 	src/crypto/crc32.cpp
 	src/crypto/hasher.cpp
+	src/crypto/hasher.cpp
+	src/crypto/iteratedhash.hpp
+	src/crypto/md5.hpp
 	src/crypto/md5.cpp
+	src/crypto/sha1.hpp
 	src/crypto/sha1.cpp
 	
+	src/loader/exereader.hpp
 	src/loader/exereader.cpp
+	src/loader/offsets.hpp
 	src/loader/offsets.cpp
 	
+	src/setup/component.hpp
 	src/setup/component.cpp
+	src/setup/data.hpp
 	src/setup/data.cpp
+	src/setup/delete.hpp
 	src/setup/delete.cpp
+	src/setup/directory.hpp
 	src/setup/directory.cpp
+	src/setup/expression.hpp
 	src/setup/expression.cpp
+	src/setup/file.hpp
 	src/setup/file.cpp
+	src/setup/filename.hpp
 	src/setup/filename.cpp
+	src/setup/header.hpp
 	src/setup/header.cpp
+	src/setup/icon.hpp
 	src/setup/icon.cpp
+	src/setup/info.hpp
 	src/setup/info.cpp
+	src/setup/ini.hpp
 	src/setup/ini.cpp
+	src/setup/item.hpp
 	src/setup/item.cpp
+	src/setup/language.hpp
 	src/setup/language.cpp
+	src/setup/message.hpp
 	src/setup/message.cpp
+	src/setup/permission.hpp
 	src/setup/permission.cpp
+	src/setup/registry.hpp
 	src/setup/registry.cpp
+	src/setup/run.hpp
 	src/setup/run.cpp
+	src/setup/task.hpp
 	src/setup/task.cpp
+	src/setup/type.hpp
 	src/setup/type.cpp
+	src/setup/version.hpp
 	src/setup/version.cpp
+	src/setup/windows.hpp
 	src/setup/windows.cpp
 	
+	src/stream/block.hpp
 	src/stream/block.cpp
+	src/stream/checksum.hpp
+	src/stream/chunk.hpp
 	src/stream/chunk.cpp
+	src/stream/exefilter.hpp
+	src/stream/file.hpp
 	src/stream/file.cpp
-	
+	src/stream/lzma.hpp
+	src/stream/lzma.cpp if INNOEXTRACT_HAVE_LZMA
+	src/stream/restrict.hpp
+	src/stream/slice.hpp
 	src/stream/slice.cpp
+	
+	src/util/align.hpp
+	src/util/ansi.hpp
+	src/util/boostfs_compat.hpp
+	src/util/console.hpp
 	src/util/console.cpp
+	src/util/encoding.hpp
+	src/util/encoding.cpp
+	src/util/endian.hpp
+	src/util/enum.hpp
+	src/util/flags.hpp
+	src/util/fstream.hpp
+	src/util/load.hpp
 	src/util/load.cpp
+	src/util/log.hpp
 	src/util/log.cpp
+	src/util/math.hpp
+	src/util/output.hpp
+	src/util/process.hpp
+	src/util/process.cpp
+	src/util/storedenum.hpp
+	src/util/time.hpp
 	src/util/time.cpp
+	src/util/types.hpp
+	src/util/unique_ptr.hpp
+	src/util/windows.hpp
+	src/util/windows.cpp if WIN32
 	
 )
 
-if(DEBUG)
-	list(APPEND INNOEXTRACT_SOURCES src/cli/debug.cpp)
-endif()
-
-if(LZMA_FOUND)
-	list(APPEND INNOEXTRACT_SOURCES src/stream/lzma.cpp)
-endif()
-
-if(WIN32)
-	list(APPEND INNOEXTRACT_SOURCES src/util/windows.cpp)
-endif()
-
-file(GLOB_RECURSE ALL_INCLUDES "${CMAKE_SOURCE_DIR}/src/*.hpp")
-
-list(SORT INNOEXTRACT_SOURCES)
-list(SORT ALL_INCLUDES)
-
-list(APPEND CHECKED_SOURCES ${INNOEXTRACT_SOURCES})
+filter_list(INNOEXTRACT_SOURCES ALL_INNOEXTRACT_SOURCES)
+
+create_source_groups(ALL_INNOEXTRACT_SOURCES)
 
 
 # Prepare generated files
@@ -288,12 +397,12 @@
 set(VERSION_FILE "${CMAKE_BINARY_DIR}/release.cpp")
 set(VERSION_SOURCES VERSION "VERSION" LICENSE "LICENSE")
 version_file("src/release.cpp.in" "${VERSION_FILE}" "${VERSION_SOURCES}" ".git")
-list(APPEND INNOEXTRACT_SOURCES "${VERSION_FILE}")
+list(APPEND INNOEXTRACT_SOURCES ${VERSION_FILE})
 
 
 # Main targets
 
-add_executable(innoextract ${INNOEXTRACT_SOURCES} ${ALL_INCLUDES})
+add_executable(innoextract ${INNOEXTRACT_SOURCES})
 target_link_libraries(innoextract ${LIBRARIES})
 
 install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
@@ -303,24 +412,5 @@
 
 # Additional targets.
 
-add_style_check_target(style "${CHECKED_SOURCES}" "${ALL_INCLUDES}")
-
-add_doxygen_target(doc "doc/Doxyfile.in" "VERSION" ".git" "${CMAKE_BINARY_DIR}/doc")
-
-
-# Print a configuration summary
-
-message("")
-message("Configuration:")
-message(" - Build type: ${CMAKE_BUILD_TYPE}")
-print_configuration("LZMA decompression" FIRST
-	INNOEXTRACT_HAVE_LZMA "enabled"
-	1                     "disabled"
-)
-print_configuration("File time precision" FIRST
-	INNOEXTRACT_HAVE_UTIMENSAT_d "nanoseconds"
-	WIN32                        "100-nanoseconds"
-	INNOEXTRACT_HAVE_UTIMES      "microseconds"
-	1                            "seconds"
-)
-message("")
+add_style_check_target(style "${ALL_INNOEXTRACT_SOURCES}" innoextract)
+

=== debian/changelog ===
innoextract (1.5-1) unstable; urgency=low

  * New upstream release (Closes: #799985)

 -- Lennart Weller <lhw@ring0.de>  Fri, 25 Sep 2015 08:37:46 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
 Homepage: https://github.com/dscharrer/InnoExtract
@@ -26,4 +26,4 @@
  Inno Setup is a tool to create installers for Microsoft Windows applications.
  Inno Extracts allows one to extract such installers under non-windows systems
  without running the actual installer using wine. Inno Extract currently
- supports installers created by Inno Setup 1.2.10 to 5.4.3.
+ supports installers created by Inno Setup 1.2.10 to 5.5.5.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,9 @@
 #!/usr/bin/make -f
+
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+CFLAGS+=$(CPPFLAGS)
+CXXFLAGS+=$(CPPFLAGS)
 
 %:
 	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
	https://github.com/dscharrer/InnoExtract/tags .*/v?(\d\S*)\.tar\.gz

## innoextract 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,16 @@
 
 cmake_minimum_required(VERSION 2.8)
 
+if(CMAKE_VERSION VERSION_GREATER 3.4)
+	cmake_policy(VERSION 3.4)
+else()
+	cmake_policy(VERSION ${CMAKE_VERSION})
+endif()
+
 
 # Define configuration options
 
+option(STRICT_USE "Abort if there are missing optional dependencies"  OFF)
 option(USE_LZMA "Build lzma decompression support" ON)
 set(WITH_CONV CACHE STRING "The library to use for charset conversions")
 option(ENABLE_BUILTIN_CONV "Build internal charset conversion routines" ON)
@@ -172,7 +179,7 @@
 
 # Set compiler flags
 
-if(${Boost_VERSION} LESS 104800)
+if(Boost_VERSION LESS 104800)
 	# Older Boost versions don't work with C++11
 elseif(USE_CXX11)
 	enable_cxx11()
@@ -191,7 +198,7 @@
 
 # Older glibc versions won't provide some useful symbols by default - request them
 # This flag is currently also set by gcc when compiling C++, but not for plain C
-if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+if(CMAKE_SYSTEM_NAME MATCHES "Linux")
 	set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
 	add_definitions(-D_GNU_SOURCE=1)
 endif()
@@ -407,10 +414,3 @@
 
 install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 
-install(FILES doc/innoextract.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 OPTIONAL)
-
-
-# Additional targets.
-
-add_style_check_target(style "${ALL_INNOEXTRACT_SOURCES}" innoextract)
-

=== debian/changelog ===
innoextract (1.6-1build3) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:16:53 +0000

innoextract (1.6-1build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:24:15 +0000

innoextract (1.6-1build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:19:28 +0000

innoextract (1.6-1) unstable; urgency=low

  * New upstream release
  * Added build-hardening flags
  * Updated Homepage and Vcs-URLs
  * Updated debian Standards-Version
  * Updated watch file with PGP support and releases instead of tags

 -- Lennart Weller <lhw@ring0.de>  Fri, 08 Apr 2016 11:52:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: innoextract
 Section: utils
 Priority: extra
-Maintainer: Lennart Weller <lhw@ring0.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.6
-Vcs-git: git://anonscm.debian.org/collab-maint/innoextract.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/innoextract.git
-Homepage: https://github.com/dscharrer/InnoExtract
+Standards-Version: 3.9.7
+Vcs-git: https://anonscm.debian.org/git/collab-maint/innoextract.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/innoextract.git
+Homepage: http://constexpr.org/innoextract/
 Build-Depends: cmake,
                debhelper (>= 9),
                dpkg-dev (>= 1.16.1~),
@@ -26,4 +27,4 @@
  Inno Setup is a tool to create installers for Microsoft Windows applications.
  Inno Extracts allows one to extract such installers under non-windows systems
  without running the actual installer using wine. Inno Extract currently
- supports installers created by Inno Setup 1.2.10 to 5.5.5.
+ supports installers created by Inno Setup 1.2.10 to 5.5.8.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 CFLAGS+=$(CPPFLAGS)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/,pgpsigurlmangle=s/$/.sig/ \
	https://github.com/dscharrer/innoextract/releases .*?/(?:\d\S*)/innoextract-(\d\S*)\.tar\.gz

## innoextract 1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,18 +11,30 @@
 
 # Define configuration options
 
+macro(suboption _var _comment _type _default)
+	if(NOT DEFINED ${_var})
+		set(${_var} "${_default}")
+	else()
+		set(${_var} "${${_var}}" CACHE ${_type} "${_comment}")
+	endif()
+endmacro()
+
 option(STRICT_USE "Abort if there are missing optional dependencies"  OFF)
-option(USE_LZMA "Build lzma decompression support" ON)
+option(USE_ARC4 "Build ARC4 decryption support" ON)
+option(USE_LZMA "Build LZMA decompression support" ON)
 set(WITH_CONV CACHE STRING "The library to use for charset conversions")
-option(ENABLE_BUILTIN_CONV "Build internal charset conversion routines" ON)
 option(DEBUG_EXTRA "Expensive debug options" OFF)
 option(SET_WARNING_FLAGS "Adjust compiler warning flags" ON)
 option(SET_OPTIMIZATION_FLAGS "Adjust compiler optimization flags" ON)
-option(USE_CXX11 "Try to use C++11 if available" ON)
+suboption(CXX_STD_VERSION "Maximum C++ standard version to enable" STRING 2017)
 option(USE_DYNAMIC_UTIMENSAT "Dynamically load utimensat if not available at compile time" OFF)
-if(NOT DEFINED DEBUG AND CMAKE_BUILD_TYPE STREQUAL "Debug")
-	set(DEBUG 1)
-endif()
+
+set(default_DEBUG OFF)
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+	set(default_DEBUG ON)
+endif()
+suboption(DEBUG "Build with debug output" BOOL ${default_DEBUG})
+
 if(DEBUG)
 	add_definitions(-DDEBUG=1)
 endif()
@@ -61,11 +73,11 @@
 
 include(CheckSymbolExists)
 
-set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake") # For custom cmake modules
+set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake") # For custom cmake modules
 include(BuildType)
 include(CompileCheck)
 include(CreateSourceGroups)
-include(CXX11Check)
+include(CXXVersionCheck)
 include(Doxygen)
 include(FilterList)
 include(PrintConfiguration)
@@ -106,6 +118,10 @@
 
 unset(LIBRARIES)
 
+if(USE_ARC4)
+	set(INNOEXTRACT_HAVE_ARC4 1)
+endif()
+
 if(USE_LZMA)
 	find_package(LZMA REQUIRED)
 	check_link_library(LZMA LZMA_LIBRARIES)
@@ -150,7 +166,6 @@
 
 set(INNOEXTRACT_HAVE_ICONV 0)
 set(INNOEXTRACT_HAVE_WIN32_CONV 0)
-set(INNOEXTRACT_HAVE_BUILTIN_CONV ${ENABLE_BUILTIN_CONV})
 if(WIN32 AND (NOT WITH_CONV OR WITH_CONV STREQUAL "win32"))
 	set(INNOEXTRACT_HAVE_WIN32_CONV 1)
 elseif(NOT WITH_CONV OR WITH_CONV STREQUAL "iconv")
@@ -170,19 +185,14 @@
 elseif(WITH_CONV AND NOT WITH_CONV STREQUAL "builtin")
 	message(FATAL_ERROR "Invalid WITH_CONV option: ${WITH_CONV}")
 endif()
-if(NOT INNOEXTRACT_HAVE_ICONV AND NOT INNOEXTRACT_HAVE_WIN32_CONV
-   AND NOT INNOEXTRACT_HAVE_BUILTIN_CONV)
-	message(WARNING "\nBuilding without any charset conversion support.\n"
-	                "Any non-ASCII characters in extracted filenames will be missing.")
-endif()
 
 
 # Set compiler flags
 
 if(Boost_VERSION LESS 104800)
 	# Older Boost versions don't work with C++11
-elseif(USE_CXX11)
-	enable_cxx11()
+elseif(NOT CXX_STD_VERSION LESS 2011)
+	enable_cxx_version(${CXX_STD_VERSION})
 	check_cxx11("alignof" INNOEXTRACT_HAVE_ALIGNOF)
 	if(WIN32)
 		check_cxx11("std::codecvt_utf8_utf16" INNOEXTRACT_HAVE_STD_CODECVT_UTF8_UTF16 1600)
@@ -248,6 +258,10 @@
 		check_symbol_exists(waitpid "sys/wait.h" INNOEXTRACT_HAVE_WAITPID)
 	endif()
 	
+endif()
+
+if(NOT MSVC)
+	
 	if(CMAKE_CXX_COMPILER_ID STREQUAL "PathScale")
 		# EKOPath recognizes these but then fails to link
 	else()
@@ -283,10 +297,14 @@
 	src/cli/extract.cpp
 	src/cli/gog.hpp
 	src/cli/gog.cpp
+	src/cli/goggalaxy.hpp
+	src/cli/goggalaxy.cpp
 	src/cli/main.cpp
 	
 	src/crypto/adler32.hpp
 	src/crypto/adler32.cpp
+	src/crypto/arc4.hpp if INNOEXTRACT_HAVE_ARC4
+	src/crypto/arc4.cpp if INNOEXTRACT_HAVE_ARC4
 	src/crypto/checksum.hpp
 	src/crypto/checksum.cpp
 	src/crypto/crc32.hpp
@@ -401,16 +419,8 @@
 
 configure_file("src/configure.hpp.in" "configure.hpp")
 
-set(VERSION_FILE "${CMAKE_BINARY_DIR}/release.cpp")
+set(VERSION_FILE "${PROJECT_BINARY_DIR}/release.cpp")
 set(VERSION_SOURCES VERSION "VERSION" LICENSE "LICENSE")
-version_file("src/release.cpp.in" "${VERSION_FILE}" "${VERSION_SOURCES}" ".git")
+version_file("src/release.cpp.in" ${VERSION_FILE} "${VERSION_SOURCES}" ".git")
 list(APPEND INNOEXTRACT_SOURCES ${VERSION_FILE})
 
-
-# Main targets
-
-add_executable(innoextract ${INNOEXTRACT_SOURCES})
-target_link_libraries(innoextract ${LIBRARIES})
-
-install(TARGETS innoextract RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-

=== debian/changelog ===
innoextract (1.7-2) unstable; urgency=medium

  * upstream patch: fix larger than 2GiB slices (Closes: #903312)

 -- Lennart Weller <lhw@ring0.de>  Fri, 02 Nov 2018 08:59:05 +0100

innoextract (1.7-1) unstable; urgency=medium

  [ Lennart Weller ]
  * new upstream release (Closes: #902579)

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass cross compilers to cmake (Closes: #870652)

 -- Lennart Weller <lhw@ring0.de>  Sun, 01 Jul 2018 20:01:04 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: innoextract
 Section: utils
-Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Lennart Weller <lhw@ring0.de>
+Priority: optional
+Maintainer: Lennart Weller <lhw@ring0.de>
 Uploaders: Sebastian Reichel <sre@debian.org>
-Standards-Version: 3.9.7
-Vcs-git: https://anonscm.debian.org/git/collab-maint/innoextract.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/innoextract.git
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/lhw-guest/innoextract
+Vcs-git: https://salsa.debian.org/lhw-guest/innoextract.git
 Homepage: http://constexpr.org/innoextract/
 Build-Depends: cmake,
                debhelper (>= 9),
